﻿public class Sniper : Mod
{
    private HarmonyLib.Harmony harmony;
    private static string modId = "com.raftmodding.mods.sniper";
    private static UnityEngine.Vector3 bowThrowForce = new UnityEngine.Vector3(0f, 125f, 1500f);
    private static float bowHideDelay = 0.5f;
    private static bool bowHideDuringCooldown = true;
    private static UnityEngine.Vector3 netGunThrowForce = new UnityEngine.Vector3(0f, 150f, 1000f);
    private static float? bowChargeSpeed;
    public void Start()
    {
        foreach (ThrowableComponent_Bow bow in UnityEngine.Resources.FindObjectsOfTypeAll<ThrowableComponent_Bow>())
        {
            if (bow.name == "Bow")
            {
                HarmonyLib.Traverse traverse = HarmonyLib.Traverse.Create(bow);
                bowThrowForce = traverse.Field("throwForce").GetValue<UnityEngine.Vector3>();
                bowHideDelay = traverse.Field("hideDelay").GetValue<float>();
                bowHideDuringCooldown = traverse.Field("hideDuringCooldown").GetValue<bool>();
                break;
            }
        }
        foreach (ThrowableComponent_NetGun netGun in UnityEngine.Resources.FindObjectsOfTypeAll<ThrowableComponent_NetGun>())
        {
            if (netGun.name == "NetGun")
            {
                netGunThrowForce = HarmonyLib.Traverse.Create(netGun).Field("throwForce").GetValue<UnityEngine.Vector3>();
                break;
            }
        }
        harmony = new HarmonyLib.Harmony(modId);
        harmony.PatchAll();
    }
    public void OnModUnload()
    {
        harmony.UnpatchAll(modId);
        foreach (ThrowableComponent_Bow bow in UnityEngine.Resources.FindObjectsOfTypeAll<ThrowableComponent_Bow>())
        {
            HarmonyLib.Traverse traverse = HarmonyLib.Traverse.Create(bow);
            traverse.Field("throwForce").SetValue(bowThrowForce);
            traverse.Field("hideDelay").SetValue(bowHideDelay);
            traverse.Field("hideDuringCooldown").SetValue(bowHideDuringCooldown);
            HarmonyLib.Traverse.Create(traverse.Field("chargeMeter").GetValue<ChargeMeter>()).Field("chargeSpeed").SetValue(bowChargeSpeed ?? 75f);
        }
        foreach (ThrowableComponent_NetGun netGun in UnityEngine.Resources.FindObjectsOfTypeAll<ThrowableComponent_NetGun>())
        {
            HarmonyLib.Traverse.Create(netGun).Field("throwForce").SetValue(netGunThrowForce);
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(ThrowableComponent_Bow), "CallStartChargeEvent")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_ThrowableComponentBow_CallStartChargeEvent
    {
        static void Prefix(ref UnityEngine.Vector3 ___throwForce, ref bool ___hideDuringCooldown, ref float ___hideDelay, ref ChargeMeter ___chargeMeter)
        {
            if (bowChargeSpeed == null)
            {
                bowChargeSpeed = HarmonyLib.Traverse.Create(___chargeMeter).Field("chargeSpeed").GetValue<float>();
            }
            HarmonyLib.Traverse.Create(___chargeMeter).Field("chargeSpeed").SetValue(5000f);
            ___throwForce = new UnityEngine.Vector3(0f, 0f, 4000f);
            ___hideDelay = 0f;
            ___hideDuringCooldown = false;
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(ThrowableComponent_NetGun), "HandleShoot")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_ThrowableComponentNetGun_HandleShoot
    {
        static void Prefix(ref UnityEngine.Vector3 ___throwForce)
        {
            ___throwForce = new UnityEngine.Vector3(0f, 0f, 4000f);
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Throwable_Object), "Initialize", new System.Type[] { typeof(ThrowableComponent), typeof(uint), typeof(uint), typeof(UnityEngine.Vector3), typeof(bool) })]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_ThrowableObject_Initialize
    {
        static void Prefix(ref bool ___useWaterCollision, ref float ___defaultDrag, ref UnityEngine.Rigidbody ___body, ref float ___waterDrag, ref ThrowableComponent throwableComponent, ref uint throwableIndex, ref uint throwablePickupIndex, ref UnityEngine.Vector3 force, ref bool colliderEnabled)
        {
            if (___body.name.Substring(0, 6) == "Arrow_" || ___body.name.Substring(0, 21) == "Throwable_CaptureNet(")
            {
                ___defaultDrag = 0f;
                ___body.drag = 0f;
                ___body.useGravity = false;
                ___useWaterCollision = false;
                ___waterDrag = 0f;
            }
        }
    }
}
